#!/usr/bin/env python
# -*- coding: utf-8 -*-
# generated by wxGlade 0.6.3 on Thu May 12 05:27:10 2011
# some bugFix by E.Mogura, May 21 2012
# some bugFix by E.Mogura, June 5 2012
# runJGP (ajust jgp project file) by E.Mogura, Sep 23 2019

import gi
#import wx
import os
import re
import sys
import glob
from subprocess import *
import dexcsTextSearcher
import gettext

gi.require_version("Gtk", "3.0")
from gi.repository import Gtk

class MyDialog1(Gtk.Window):
    def __init__(self, *args, **kwds):
        if len(args)>3 :
    
            self.cmd = args[-1]
            self.title = args[-2]
            self.msg = args[-3]
            args = args[0:2]
        Gtk.Window.__init__(self, title=self.title)

        self.set_default_size(150, 100)
        self.set_border_width(10)

        label = Gtk.Label(self.msg)

        button1 = Gtk.Button.new_with_label("OK")
        button1.connect("clicked", self.on_ok_clicked)

        button2 = Gtk.Button.new_with_label("Cancel")
        button2.connect("clicked", self.on_cancel_clicked)

        vbox = Gtk.Box(orientation=Gtk.Orientation.VERTICAL, spacing=20)
        hbox = Gtk.Box(orientation=Gtk.Orientation.HORIZONTAL, spacing=6)

        hbox.pack_start(button1, True, True, 0)
        hbox.pack_start(button2, True, True, 0)

        self.add(vbox)

        vbox.pack_start(label, True, True, 0)
        vbox.pack_start(hbox, True, True, 0)

        self.show_all()

    def on_ok_clicked(self, widget):
        cmd1 = self.cmd
        f=open("run","w")
        f.write(cmd1)
        f.close()
        #実行権付与
        os.system("chmod a+x run")
        #実行
        #comm = "gnome-terminal -t " + caseName + " --geometry=80x15 --zoom=0.9 -x bash --rcfile run &"
        comm = "gnome-terminal -t . --geometry=80x15 --zoom=0.9 -- bash --rcfile run &"
        os.system(comm)
        print("## EXEC ... " + cmd1 + " ... submitted.")
        self.destroy()

    def on_cancel_clicked(self, widget):
        #print("Cancel button clicked")
        self.destroy()

class DialogWindow(Gtk.Window):
    def __init__(self):
        Gtk.Window.__init__(self, title="Dialog Example")

        self.set_border_width(6)

        button = Gtk.Button("Open dialog")
        button.connect("clicked", self.on_button_clicked)

        self.add(button)

    def on_button_clicked(self, widget):
        dialog = DialogExample(self)
        response = dialog.run()

        if response == Gtk.ResponseType.OK:
            print("The OK button was clicked")
        elif response == Gtk.ResponseType.CANCEL:
            print("The Cancel button was clicked")

        dialog.destroy()


def ErrorDialog(message):
        dialog = Gtk.MessageDialog(parent=None,
            flags=0,
            type=Gtk.MessageType.ERROR,
            buttons=Gtk.ButtonsType.CANCEL,
            message_format="This is an ERROR MessageDialog"
        )
        dialog.format_secondary_text(
            message
        )
        dialog.run()
        print("ERROR dialog closed")

        dialog.destroy()

def checkOpenFoamFileSystem(location):
        
        systemFolder = location + "/system"
        
        if not os.path.isdir(systemFolder):
            ErrorDialog(_("systemフォルダが見つからないので、\nOpenFOAMのケースフォルダとして認識できません"))   
            return False
        elif not os.path.isdir(location + "/constant"):
            ErrorDialog(_("constantフォルダが見つからないので、\nOpenFOAMのケースフォルダとして認識できません"))    
            return False
        #elif not os.path.isdir(location + "/0"):
        #    self.ErrorDialog(u"0 フォルダが見つからないので、\nOpenFOAMのケースフォルダとして認識できません")    
        #    return False
        elif not os.path.isfile(location + "/system/controlDict"):
            ErrorDialog(_("system/controlDict が見つからないので、\nOpenFOAMのケースフォルダとして認識できません"))    
            return False
        else :
            return True

def checkPolyMesh(location):
        if os.path.basename(location) != "polyMesh":
            ErrorDialog(_("選択されたフォルダはOpenFOAMの\nメッシュフォルダ（polyMesh）がありません"))    
            return False
        elif not os.path.isfile(location +"/points") and not os.path.isfile(location +"/points.gz"):
            ErrorDialog(_("選択されたフォルダ（polyMesh）には\nメッシュデータ（points）がありません"))    
            return False
        elif not os.path.isfile(location +"/faces") and not os.path.isfile(location +"/faces.gz") :
            ErrorDialog(_("選択されたフォルダ（polyMesh）には\nメッシュデータ（faces）がありません"))    
            return False
        elif not os.path.isfile(location +"/owner") and not os.path.isfile(location +"/owner.gz"):
            ErrorDialog(_("選択されたフォルダ（polyMesh）には\nメッシュデータ（owner）がありません"))    
            return False       
        elif not os.path.isfile(location +"/neighbour") and not os.path.isfile(location +"/neighbour.gz") :
            ErrorDialog(_("選択されたフォルダ（polyMesh）には\nメッシュデータ（neighbour）がありません"))    
            return False
        else :
            return True       


def dispBlockMesh(caseDir,envOF): # 
            DexcsSwakCommand = _("blockMeshの表示")
            title = DexcsSwakCommand
            msg = DexcsSwakCommand + _("を実行します")
            #cmd = ". " + envOF + ";pyFoamDisplayBlockMesh.py ./constant/polyMesh/blockMeshDict &"
            cmd = ". " + envOF + ";paraFoam -blockMesh &"
            os.chdir(caseDir)
            if not ( os.path.exists(caseDir + "/constant/polyMesh/blockMeshDict") or os.path.exists(caseDir + "/system/blockMeshDict")):           
                ErrorDialog(_("system/blockMeshDict がありません"))    
                return False
            else :
                runCommand(msg, title, cmd)

def runBlockMesh(caseDir,envOF): # 2014/12/17 by E.Mogura
            DexcsSwakCommand = _("blockMeshの作成")
            title = DexcsSwakCommand
            msg = DexcsSwakCommand + _("を実行します")
            os.chdir(caseDir)
            if checkOpenFoamFileSystem(caseDir) :
                shHead =  "#!/bin/bash\n"
                envSet = ". " + envOF + "\n"
                solverSet = "blockMesh | tee blockmesh.log\n"
                cmd = shHead + envSet + solverSet
                runCommand(msg, title, cmd)
            else:
                ErrorDialog(DexcsSwakCommand + _("\nを実行できませんでした"))    

def runCheckMesh(caseDir,envOF): # 2014/12/17 by E.Mogura
            DexcsSwakCommand = _("checkMesh")
            title = DexcsSwakCommand
            msg = DexcsSwakCommand + _("を実行します")
            os.chdir(caseDir)
            if checkOpenFoamFileSystem(caseDir) :
                shHead =  "#!/bin/bash\n"
                envSet = ". " + envOF + "\n"
                solverSet = "checkMesh | tee checkmesh.log\n"
                cmd = shHead + envSet + solverSet
                runCommand(msg, title, cmd)
            else:
                ErrorDialog(DexcsSwakCommand + _("\nを実行できませんでした"))    

def runCfMesh(caseDir,envOF): # 2014/12/17 by E.Mogura
            DexcsSwakCommand = _("cfMesh(cartesianMesh)の作成")
            title = DexcsSwakCommand
            msg = DexcsSwakCommand + _("を実行します")
            os.chdir(caseDir)
            if checkOpenFoamFileSystem(caseDir) :
                shHead =  "#!/bin/bash\n"
                envSet = ". " + envOF + "\n"
                solverSet = "cartesianMesh | tee cfmesh.log\n"
                cmd = shHead + envSet + solverSet
                runCommand(msg, title, cmd)
            else:
                ErrorDialog(DexcsSwakCommand + _("\nを実行できませんでした"))    

def runAllrun(caseDir,envOF): # 2014/09 by E.Mogura
            DexcsSwakCommand = _("Allrun")
            title = DexcsSwakCommand
            msg = DexcsSwakCommand + _("を実行します")
            os.chdir(caseDir)
            if checkOpenFoamFileSystem(caseDir) :                #cfmesh.logのクリア
                shHead =  "#!/bin/bash\n"
                envSet = ". " + envOF + "\n"
                solverSet = "./Allrun \n"
                cmd = shHead + envSet + solverSet
                runCommand(msg, title, cmd)
            else:
                ErrorDialog(DexcsSwakCommand + _("\nを実行できませんでした"))    

def runAllclean(caseDir,envOF): # 2014/09 by E.Mogura
            DexcsSwakCommand = _("Allclean")
            title = DexcsSwakCommand
            msg = DexcsSwakCommand + _("を実行します")
            os.chdir(caseDir)
            if checkOpenFoamFileSystem(caseDir) :
                title =  "#!/bin/bash\n"
                envSet = ". " + envOF + "\n"
                solverSet = "./Allclean \n"
                cmd = title + envSet + solverSet
                runCommand(msg, title, cmd)
            else:
                ErrorDialog(DexcsSwakCommand + _("\nを実行できませんでした"))    

def runSubmitJob(caseDir,envOF): # 2014/09/18 by E.Mogura
            DexcsSwakCommand = _("バッチジョブのサブミット")
            title = DexcsSwakCommand
            msg = DexcsSwakCommand + _("を実行します")
            os.chdir(caseDir)
#            dlg = wx.FileDialog(None, message=_(u"サブミットファイルを選択してください"), 
#            defaultDir = caseDir,
#            style=wx.DD_DEFAULT_STYLE | wx.DD_NEW_DIR_BUTTON)
#            if dlg.ShowModal() == wx.ID_OK:
#                setSubmitFile = dlg.GetPath()
            fn = Gtk.FileChooserDialog(
                _("サブミットファイルを選択してください"),
                None,
                Gtk.FileChooserAction.OPEN,
                (
                    Gtk.STOCK_CANCEL,
                    Gtk.ResponseType.CANCEL,
                    Gtk.STOCK_OPEN,
                    Gtk.ResponseType.OK,
                ),
            	)
            fn.show()

            resp = fn.run()
            if resp == Gtk.ResponseType.OK:
                setSubmitFile = fn.get_filename()
            fn.destroy() 
            if os.path.isfile(setSubmitFile):
                #cmd = "sbatch " + setSubmitFile + " &"
                cmd = "sbatch " + setSubmitFile
                runCommand(msg, title, cmd)

def runSubmitStatus(caseDir,envOF): # 2014/09/18 by E.Mogura
		#cmd = "gnome-terminal -t dexcsSwak --geometry=100x10-0-0 --zoom=0.9 -x sh -c 'squeue;exec bash' &"            
		cmd = "gnome-terminal -t dexcsSwak --geometry=100x10-0-0 --zoom=0.9 -- sh -c 'squeue;exec bash' &"            
		os.system(cmd)


def runJGP(caseDir, envOF): 
            DexcsSwakCommand = _("JGPプロジェクトファイルの適合とJGP起動")
            title = DexcsSwakCommand
            os.chdir(caseDir)
            fn = Gtk.FileChooserDialog(
                _("JGPプロジェクトファイルを選択してください"),
                None,
                Gtk.FileChooserAction.OPEN,
                (
                    Gtk.STOCK_CANCEL,
                    Gtk.ResponseType.CANCEL,
                    Gtk.STOCK_OPEN,
                    Gtk.ResponseType.OK,
                ),
            )
            _filter = Gtk.FileFilter()
            _filter.set_name("JGP Files")
            _filter.add_pattern("*.jgp")
            fn.add_filter(_filter)
            _filter = Gtk.FileFilter()
            _filter.set_name("All Files")
            _filter.add_pattern("*")
            fn.add_filter(_filter)
            fn.show()

            resp = fn.run()
            if resp == Gtk.ResponseType.OK:
                fileName = fn.get_filename()
            fn.destroy() 
            if os.path.isfile(fileName):

                f = open(fileName,"r")
                lines = f.readlines()
                f.close()

                outputFile=open(fileName+'.org','w')

                outputFile.writelines(lines)
                outputFile.close()

                outputFile=open(fileName,'w')

                for line in lines:
                   lineConv = line
                   f1 = line.find('<filename>')
                   f2 = line.find('/postProcessing/')
                   if f1 > -1 and f2 > -1 :
                       lineConv = line[0:f1+10] + caseDir + line[f2:-1]
                   outputFile.write(lineConv)
                outputFile.close()

                f = open("/opt/jgp/.JGP", "r")
                lines = f.readlines()
                f.close()

                outputFile = open("/opt/jgp/.JGP", 'w')
                for i in range(len(lines)):
                   line = lines[i]
                   outputFile.write(line)
                   if i == 3 :
                       outputFile.write('        <project>\n')
                       outputFile.write('            <filename>' + fileName + '</filename>\n')
                       outputFile.write('        </project>\n')
                outputFile.close()

                message = fileName + "\n has been adjusted for the included caseName.\n"
                msg = message + _("引き続きJGPを起動します")
                shHead =  "#!/bin/bash\n"
                cmd = shHead + "/opt/jgp/startupJgp"
                runCommand(msg, title, cmd)

def runSearch(envOF): 
            cmd = ". " + envOF + ";cd $FOAM_TUTORIALS;pwd > /tmp/dexcsSwak.tmp"
            #print('dbg1',cmd)
            p = os.system(cmd)
            tutDirFile = open('/tmp/dexcsSwak.tmp','r') 
            for line in tutDirFile :      
             tutDir = line.rstrip()
            tutDirFile.close()
            DexcsSwakCommand = _("ソースコード検索")
            #print('dbg2',tutDir)
            app = dexcsTextSearcher.GtkGladeSample()
            app.main()
            
def runCommand(msg,title,cmd):
        if cmd !="":
            #try:
                dlg = MyDialog1(None, -1, "", msg, title, cmd)
                #dlg.show_all()
            #finally:
                #dlg.destroy()

#---------------------------------------------------------------------------
def setLanguage1(lang):  
        treeFoamPath = os.environ["TreeFoamPath"]
        if lang == "English":
            os.environ["LANG"] = "en_US.UTF-8"
            os.environ["LANGUAGE"] = "en_US.UTF-8"
            gettext.install("treefoam", treeFoamPath + "/locale")
        else:
            os.environ["LANG"] = "ja_JP.UTF-8"
            os.environ["LANGUAGE"] = "ja_JP.UTF-8"
            gettext.install("treefoam", treeFoamPath + "/locale")
        return
#---------------------------------------------------------------------------
if __name__ == '__main__':

    fileName = os.path.expanduser("~") + "/Desktop/DEXCS/launcherOpen/locale/langDict"
    f=open(fileName); contents = f.readlines(); f.close()
    languageFix = contents[0].split()
    setLanguage1(languageFix[0])
    app = wx.App(0)
    app.main()
